diff --git a/krita/image/tiles3/kis_memento_manager.cc b/krita/image/tiles3/kis_memento_manager.cc
index e6c71ea..a2260e1 100644
--- a/krita/image/tiles3/kis_memento_manager.cc
+++ b/krita/image/tiles3/kis_memento_manager.cc
@@ -46,19 +46,42 @@
 #endif
 
 
+/**
+ * The class is supposed to store the changes of the paint device
+ * it is associated with. The history of changes is presented in form
+ * of transactions (revisions). If you purge the history of one
+ * transaction (revision) with purgeHistory() we won't be able to undo
+ * the changes made by this transactions.
+ *
+ * The Memento Manager can be in two states:
+ *     - Named Transaction is in progress - it means the caller
+ *       has explicitly requested creation of a new transaction.
+ *       The handle for the transaction is stored on a side of
+ *       the caller. And the history will be automatically purged
+ *       when the handler dies.
+ *     - Anonymous Transaction is in progress - the caller isn't
+ *       bothered about transactions at all. We pretend as we do
+ *       not support any versioning and do not have any historical
+ *       information. The history of such transactions is not purged
+ *       automatically, but it is free'd when younger named transaction
+ *       is purged.
+ */
+
+#define blockRegistration() (m_registrationBlocked = true)
+#define unblockRegistration() (m_registrationBlocked = false)
+#define registrationBlocked() (m_registrationBlocked)
+
+#define namedTransactionInProgress() ((bool)m_currentMemento)
+
 KisMementoManager::KisMementoManager()
     : m_index(0),
-      m_headsHashTable(0)
+      m_headsHashTable(0),
+      m_registrationBlocked(false)
 {
     /**
-     * Get an initial memento to show we want history for ALL the devices.
-     * If we don't do it, we won't be able to start history later,
-     * as we don't have any special api for this.
-     * It shouldn't create much overhead for unversioned devices as
-     * no tile-duplication accurs without calling a commit()
-     * method regularily.
+     * Tile change/delete registration is enabled for all
+     * devices by default. It can't be delayed.
      */
-    (void) getMemento();
 }
 
 KisMementoManager::KisMementoManager(const KisMementoManager& rhs)
@@ -66,11 +89,12 @@ KisMementoManager::KisMementoManager(const KisMementoManager& rhs)
         m_revisions(rhs.m_revisions),
         m_cancelledRevisions(rhs.m_cancelledRevisions),
         m_headsHashTable(rhs.m_headsHashTable, 0),
-        m_currentMemento(rhs.m_currentMemento)
+        m_currentMemento(rhs.m_currentMemento),
+        m_registrationBlocked(rhs.m_registrationBlocked)
 {
-    Q_ASSERT_X(m_currentMemento,
+    Q_ASSERT_X(!m_registrationBlocked,
                "KisMementoManager", "(impossible happened) "
-               "Seems like a device was created without history support");
+               "The device has been copied while registration was blocked");
 }
 
 KisMementoManager::~KisMementoManager()
@@ -100,7 +124,7 @@ KisMementoManager::~KisMementoManager()
 
 void KisMementoManager::registerTileChange(KisTile *tile)
 {
-    if (!m_currentMemento) return;
+    if (registrationBlocked()) return;
     m_cancelledRevisions.clear();
 
     DEBUG_LOG_TILE_ACTION("reg. [C]", tile, tile->col(), tile->row());
@@ -111,7 +135,9 @@ void KisMementoManager::registerTileChange(KisTile *tile)
         mi = new KisMementoItem();
         mi->changeTile(tile);
         m_index.addTile(mi);
-        m_currentMemento->updateExtent(mi->col(), mi->row());
+
+        if(namedTransactionInProgress())
+            m_currentMemento->updateExtent(mi->col(), mi->row());
     }
     else {
         mi->reset();
@@ -121,7 +147,7 @@ void KisMementoManager::registerTileChange(KisTile *tile)
 
 void KisMementoManager::registerTileDeleted(KisTile *tile)
 {
-    if (!m_currentMemento) return;
+    if (registrationBlocked()) return;
     m_cancelledRevisions.clear();
 
     DEBUG_LOG_TILE_ACTION("reg. [D]", tile, tile->col(), tile->row());
@@ -132,7 +158,9 @@ void KisMementoManager::registerTileDeleted(KisTile *tile)
         mi = new KisMementoItem();
         mi->deleteTile(tile, m_headsHashTable.defaultTileData());
         m_index.addTile(mi);
-        m_currentMemento->updateExtent(mi->col(), mi->row());
+
+        if(namedTransactionInProgress())
+            m_currentMemento->updateExtent(mi->col(), mi->row());
     }
     else {
         mi->reset();
@@ -142,7 +170,12 @@ void KisMementoManager::registerTileDeleted(KisTile *tile)
 
 void KisMementoManager::commit()
 {
-    if (m_index.isEmpty()) return;
+    if (m_index.isEmpty()) {
+        if(namedTransactionInProgress())
+            warnTiles << "Named Transaction is empty";
+        m_currentMemento = 0;
+        return;
+    }
 
     KisMementoItemList revisionList;
     KisMementoItemSP mi;
@@ -168,8 +201,11 @@ void KisMementoManager::commit()
     hItem.memento = m_currentMemento.data();
     m_revisions.append(hItem);
 
+    m_currentMemento = 0;
     Q_ASSERT(m_index.isEmpty());
 
+    DEBUG_DUMP_MESSAGE("COMMIT_DONE");
+
     // Waking up pooler to prepare copies for us
     globalTileDataStore.kickPooler();
 }
@@ -177,34 +213,29 @@ void KisMementoManager::commit()
 KisTileSP KisMementoManager::getCommitedTile(qint32 col, qint32 row)
 {
     /**
-     * Our getOldTile mechanism is supposed to return current tile, if
-     * the history is disabled. So we return zero if no transaction
-     * is in progress.
+     * Our getOldTile mechanism is supposed to return current
+     * tile, if the history is disabled. So we return zero if
+     * no named transaction is in progress.
      */
-    if(!m_currentMemento || !m_currentMemento->valid())
+    if(!namedTransactionInProgress())
         return 0;
 
-//    KisMementoItemSP mi = m_headsHashTable.getReadOnlyTileLazy(col, row);
-//    Q_ASSERT(mi);
-//    return mi->tile(0);
-
-    /**
-     * FIXME: We emulate unversioned devices here
-     * It means that if there is no history present,
-     * we return null, instead of a default tile.
-     * This may lead to wrong results in filters
-     * I guess, should be fixed after transaction refactor...
-     */
-    KisMementoItemSP mi = m_headsHashTable.getExistedTile(col, row);
-    return mi ? mi->tile(0) : 0;
+    KisMementoItemSP mi = m_headsHashTable.getReadOnlyTileLazy(col, row);
+    Q_ASSERT(mi);
+    return mi->tile(0);
 }
 
 KisMementoSP KisMementoManager::getMemento()
 {
+    /**
+     * We do not allow nested transactions
+     */
+    Q_ASSERT(!namedTransactionInProgress());
+
     commit();
     m_currentMemento = new KisMemento(this);
 
-    DEBUG_DUMP_MESSAGE("GET_MEMENTO");
+    DEBUG_LOG_SIMPLE_ACTION("GET_MEMENTO_DONE");
 
     return m_currentMemento;
 }
@@ -212,8 +243,6 @@ KisMementoSP KisMementoManager::getMemento()
 #define forEachReversed(iter, list) \
         for(iter=list.end(); iter-- != list.begin();)
 
-#define saveAndClearMemento(memento) KisMementoSP _mem = (memento); memento=0
-#define restoreMemento(memento) (memento) = _mem
 
 void KisMementoManager::rollback(KisTileHashTable *ht)
 {
@@ -227,7 +256,7 @@ void KisMementoManager::rollback(KisTileHashTable *ht)
     KisMementoItemSP parentMI;
     KisMementoItemList::iterator iter;
 
-    saveAndClearMemento(m_currentMemento);
+    blockRegistration();
     forEachReversed(iter, changeList.itemList) {
         mi=*iter;
         parentMI = mi->parent();
@@ -245,16 +274,21 @@ void KisMementoManager::rollback(KisTileHashTable *ht)
     }
     /**
      * NOTE: tricky hack alert.
-     * We have  just deleted some tiles  from original hash  table.  And they
-     * accurately reported to us about  their death. Should have reported...
-     * But we   prevented   addition   of  their   bodies   with   zeroing
-     * m_currentMemento. All dead tiles are going to /dev/null :)
+     * We have just deleted some tiles from the original hash table.
+     * And they accurately reported to us about their death. Should
+     * have reported... But we have prevented their registration with
+     * explicitly blocking the process. So all the dead tiles are
+     * going to /dev/null :)
      *
-     * PS: It could cause some race condition... But for now we can insist on
-     * serialization  of rollback()/rollforward()  requests.Speaking  truly i
-     * can't see sny sense in calling rollback() concurrently.
+     * PS: It could cause some race condition... But we insist on
+     * serialization  of rollback()/rollforward() requests. There is
+     * not much sense in calling rollback() concurrently.
      */
-    restoreMemento(m_currentMemento);
+    unblockRegistration();
+
+    // We have just emulated a commit so:
+    m_currentMemento = 0;
+    Q_ASSERT(!namedTransactionInProgress());
 
     m_cancelledRevisions.prepend(changeList);
     DEBUG_DUMP_MESSAGE("UNDONE");
@@ -270,7 +304,7 @@ void KisMementoManager::rollforward(KisTileHashTable *ht)
 
     KisMementoItemSP mi;
 
-    saveAndClearMemento(m_currentMemento);
+    blockRegistration();
     foreach(mi, changeList.itemList) {
         if (mi->parent()->type() == KisMementoItem::CHANGED)
             ht->deleteTile(mi->col(), mi->row());
@@ -279,21 +313,11 @@ void KisMementoManager::rollforward(KisTileHashTable *ht)
 
         m_index.addTile(mi);
     }
-    /**
-     * NOTE: tricky hack alert.
-     * We have  just deleted some tiles  from original hash  table.  And they
-     * accurately reported to us about  their death. Should have reported...
-     * But we   prevented   addition   of  their   bodies   with   zeroing
-     * m_currentMemento. All dead tiles are going to /dev/null :)
-     *
-     * PS: It could cause some race condition... But for now we can insist on
-     * serialization  of rollback()/rollforward()  requests.Speaking  truly i
-     * can't see sny sense in calling rollback() concurrently.
-     */
+    // see comment in rollback()
 
     m_currentMemento = changeList.memento;
     commit();
-    restoreMemento(m_currentMemento);
+    unblockRegistration();
     DEBUG_DUMP_MESSAGE("REDONE");
 }
 
@@ -312,6 +336,8 @@ void KisMementoManager::purgeHistory(KisMementoSP oldestMemento)
 
     Q_ASSERT(m_revisions.first().memento == oldestMemento);
     resetRevisionHistory(m_revisions.first().itemList);
+
+    DEBUG_DUMP_MESSAGE("PURGE_HISTORY");
 }
 
 qint32 KisMementoManager::findRevisionByMemento(KisMementoSP memento) const
diff --git a/krita/image/tiles3/kis_memento_manager.h b/krita/image/tiles3/kis_memento_manager.h
index 8a1e68c..8509e82 100644
--- a/krita/image/tiles3/kis_memento_manager.h
+++ b/krita/image/tiles3/kis_memento_manager.h
@@ -140,10 +140,19 @@ protected:
 
     /**
      * Stores extent of current INDEX.
-     *
-     * Used for reporting to the stuff at the top about our work
+     * It is the "name" of current named transaction
      */
     KisMementoSP m_currentMemento;
+
+    /**
+     * The flag that blocks registration of changes on tiles.
+     * This is a temporary state of the memento manager, that
+     * is used for travelling in history
+     *
+     * \see rollback()
+     * \see rollforward()
+     */
+    bool m_registrationBlocked;
 };
 
 #endif /* KIS_MEMENTO_MANAGER_ */
diff --git a/krita/image/tiles3/kis_tile_hash_table.h b/krita/image/tiles3/kis_tile_hash_table.h
index 952ff62..53e433f 100644
--- a/krita/image/tiles3/kis_tile_hash_table.h
+++ b/krita/image/tiles3/kis_tile_hash_table.h
@@ -38,6 +38,7 @@ class KisTileHashTableTraits
 public:
     typedef T               TileType;
     typedef KisSharedPtr<T> TileTypeSP;
+    typedef KisWeakSharedPtr<T> TileTypeWSP;
 
     KisTileHashTableTraits(KisMementoManager *mm);
     KisTileHashTableTraits(const KisTileHashTableTraits<T> &ht,
diff --git a/krita/image/tiles3/kis_tile_hash_table_p.h b/krita/image/tiles3/kis_tile_hash_table_p.h
index 3fcdb56..9bb5b2f 100644
--- a/krita/image/tiles3/kis_tile_hash_table_p.h
+++ b/krita/image/tiles3/kis_tile_hash_table_p.h
@@ -141,6 +141,16 @@ KisTileHashTableTraits<T>::unlinkTile(qint32 col, qint32 row)
 
 #ifdef SANITY_CHECKS
             tile->setNext(0);
+            TileTypeWSP checkTile = tile;
+            tile = 0;
+            Q_ASSERT_X(!m_mementoManager || !checkTile.isValid(),
+                       "KisTileHashTableTraits::unlinkTile()",
+                       "sanity check failed: "
+                       "the tile is going to be unlinked from "
+                       "the hash table, while still being accessed "
+                       "from the outer world. It can (will) lead to wrong "
+                       "history registered by KisMementoManager. "
+                       "We'll better crash right now!");
 #endif
             m_numTiles--;
             return tile;
diff --git a/krita/image/tiles3/kis_tiled_data_manager.cc b/krita/image/tiles3/kis_tiled_data_manager.cc
index 289356f..e4370e6 100644
--- a/krita/image/tiles3/kis_tiled_data_manager.cc
+++ b/krita/image/tiles3/kis_tiled_data_manager.cc
@@ -160,8 +160,8 @@ bool KisTiledDataManager::read(KoStore *store)
 
     QIODevice *stream = store->device();
     if (!stream) {
-      nothing->setInvalid();
-      return false;
+        m_mementoManager->commit();
+        return false;
     }
 
     quint32 numTiles;
@@ -188,7 +188,7 @@ bool KisTiledDataManager::read(KoStore *store)
         tile->unlock();
     }
 
-    nothing->setInvalid();
+    m_mementoManager->commit();
     return true;
 }
 
diff --git a/krita/image/tiles3/kis_tiled_data_manager.h b/krita/image/tiles3/kis_tiled_data_manager.h
index 897e5f3..eafe111 100644
--- a/krita/image/tiles3/kis_tiled_data_manager.h
+++ b/krita/image/tiles3/kis_tiled_data_manager.h
@@ -144,6 +144,14 @@ public:
         return m_mementoManager->getMemento();
     }
 
+    /**
+     * Finishes having already started transaction
+     */
+    void commit() {
+        QWriteLocker locker(&m_lock);
+        m_mementoManager->commit();
+    }
+
     void rollback(KisMementoSP memento) {
         Q_UNUSED(memento);
         QWriteLocker locker(&m_lock);
diff --git a/krita/image/tiles3/tests/kis_tiled_data_manager_test.cpp b/krita/image/tiles3/tests/kis_tiled_data_manager_test.cpp
index 00c4e83..3062d4a 100644
--- a/krita/image/tiles3/tests/kis_tiled_data_manager_test.cpp
+++ b/krita/image/tiles3/tests/kis_tiled_data_manager_test.cpp
@@ -34,43 +34,54 @@ bool KisTiledDataManagerTest::memoryIsFilled(quint8 c, quint8 *mem, qint32 size)
 
 #define TILESIZE 64*64
 
-void KisTiledDataManagerTest::testMemento()
+void KisTiledDataManagerTest::testTransactions()
 {
     quint8 defaultPixel = 0;
     KisTiledDataManager dm(1, &defaultPixel);
 
-    quint8 oddPixel = 128;
-
-    dm.clear(0, 0, 64, 64, &oddPixel);
-    KisMementoSP memento1 = dm.getMemento();
+    quint8 oddPixel1 = 128;
+    quint8 oddPixel2 = 129;
+    quint8 oddPixel3 = 130;
 
-    dm.clear(64, 0, 64, 64, &oddPixel);
+    KisTileSP tile00;
+    KisTileSP oldTile00;
 
+    // Create a named transaction: versioning is enabled
+    KisMementoSP memento1 = dm.getMemento();
+    dm.clear(0, 0, 64, 64, &oddPixel1);
 
-    KisTileSP tile00 = dm.getTile(0, 0, false);
-    KisTileSP tile10 = dm.getTile(1, 0, false);
-    KisTileSP oldTile00 = dm.getOldTile(0, 0);
-    KisTileSP oldTile10 = dm.getOldTile(1, 0);
+    tile00 = dm.getTile(0, 0, false);
+    oldTile00 = dm.getOldTile(0, 0);
+    QVERIFY(memoryIsFilled(oddPixel1, tile00->data(), TILESIZE));
+    QVERIFY(memoryIsFilled(defaultPixel, oldTile00->data(), TILESIZE));
+    tile00 = oldTile00 = 0;
 
-    qDebug()<<ppVar(tile10)<<ppVar(oldTile10);
+    // Create an anonymous transaction: versioning is disabled
+    dm.commit();
+    tile00 = dm.getTile(0, 0, false);
+    oldTile00 = dm.getOldTile(0, 0);
+    QVERIFY(memoryIsFilled(oddPixel1, tile00->data(), TILESIZE));
+    QVERIFY(memoryIsFilled(oddPixel1, oldTile00->data(), TILESIZE));
+    tile00 = oldTile00 = 0;
 
-    QVERIFY(memoryIsFilled(oddPixel, tile00->data(), TILESIZE));
-    QVERIFY(memoryIsFilled(oddPixel, tile10->data(), TILESIZE));
-    QVERIFY(memoryIsFilled(oddPixel, oldTile00->data(), TILESIZE));
-    QVERIFY(memoryIsFilled(defaultPixel, oldTile10->data(), TILESIZE));
+    dm.clear(0, 0, 64, 64, &oddPixel2);
 
+    // Versioning is disabled, i said! >:)
+    tile00 = dm.getTile(0, 0, false);
+    oldTile00 = dm.getOldTile(0, 0);
+    QVERIFY(memoryIsFilled(oddPixel2, tile00->data(), TILESIZE));
+    QVERIFY(memoryIsFilled(oddPixel2, oldTile00->data(), TILESIZE));
+    tile00 = oldTile00 = 0;
 
+    // And the last round: named transaction:
     KisMementoSP memento2 = dm.getMemento();
+    dm.clear(0, 0, 64, 64, &oddPixel3);
 
     tile00 = dm.getTile(0, 0, false);
-    tile10 = dm.getTile(1, 0, false);
     oldTile00 = dm.getOldTile(0, 0);
-    oldTile10 = dm.getOldTile(1, 0);
-
-    QVERIFY(memoryIsFilled(oddPixel, tile00->data(), TILESIZE));
-    QVERIFY(memoryIsFilled(oddPixel, tile10->data(), TILESIZE));
-    QVERIFY(memoryIsFilled(oddPixel, oldTile00->data(), TILESIZE));
-    QVERIFY(memoryIsFilled(oddPixel, oldTile10->data(), TILESIZE));
+    QVERIFY(memoryIsFilled(oddPixel3, tile00->data(), TILESIZE));
+    QVERIFY(memoryIsFilled(oddPixel2, oldTile00->data(), TILESIZE));
+    tile00 = oldTile00 = 0;
 
 }
 
@@ -86,11 +97,11 @@ void KisTiledDataManagerTest::testPurgeHistory()
 
     KisMementoSP memento1 = dm.getMemento();
     dm.clear(0, 0, 64, 64, &oddPixel1);
+    dm.commit();
 
     KisMementoSP memento2 = dm.getMemento();
     dm.clear(0, 0, 64, 64, &oddPixel2);
 
-
     KisTileSP tile00;
     KisTileSP oldTile00;
 
@@ -110,6 +121,8 @@ void KisTiledDataManagerTest::testPurgeHistory()
     QVERIFY(memoryIsFilled(oddPixel2, tile00->data(), TILESIZE));
     QVERIFY(memoryIsFilled(oddPixel1, oldTile00->data(), TILESIZE));
 
+    dm.commit();
+
     dm.purgeHistory(memento2);
 
     /**
@@ -131,9 +144,11 @@ void KisTiledDataManagerTest::testPurgeHistory()
 
     KisMementoSP memento3 = dm.getMemento();
     dm.clear(0, 0, 64, 64, &oddPixel3);
+    dm.commit();
 
     KisMementoSP memento4 = dm.getMemento();
     dm.clear(0, 0, 64, 64, &oddPixel4);
+    dm.commit();
 
     dm.rollback(memento4);
 
diff --git a/krita/image/tiles3/tests/kis_tiled_data_manager_test.h b/krita/image/tiles3/tests/kis_tiled_data_manager_test.h
index dd753d6..145ce1b 100644
--- a/krita/image/tiles3/tests/kis_tiled_data_manager_test.h
+++ b/krita/image/tiles3/tests/kis_tiled_data_manager_test.h
@@ -29,7 +29,7 @@ private:
     bool memoryIsFilled(quint8 c, quint8 *mem, qint32 size);
 
 private slots:
-    void testMemento();
+    void testTransactions();
     void testPurgeHistory();
     void stressTest();
 };
diff --git a/krita/plugins/extensions/colorrange/colorrange.cc b/krita/plugins/extensions/colorrange/colorrange.cc
index 1a42e58..af96003 100644
--- a/krita/plugins/extensions/colorrange/colorrange.cc
+++ b/krita/plugins/extensions/colorrange/colorrange.cc
@@ -124,9 +124,7 @@ void ColorRange::selectOpaque()
         selIter.nextRow();
     }
 
-    QUndoCommand* cmd = helper.selectPixelSelection(tmpSel, SELECTION_ADD);
-    canvas->addCommand(cmd);
-    
+    helper.selectPixelSelection(tmpSel, SELECTION_ADD);
 }
 
 #include "colorrange.moc"
diff --git a/krita/plugins/extensions/colorrange/dlg_colorrange.cc b/krita/plugins/extensions/colorrange/dlg_colorrange.cc
index e475e78..2e6f004 100644
--- a/krita/plugins/extensions/colorrange/dlg_colorrange.cc
+++ b/krita/plugins/extensions/colorrange/dlg_colorrange.cc
@@ -47,7 +47,7 @@
 #include <kis_types.h>
 #include <kis_undo_adapter.h>
 #include <kis_view2.h>
-#include <kis_selected_transaction.h>
+#include <kis_transaction.h>
 #include <kis_cursor.h>
 
 namespace
@@ -184,8 +184,10 @@ DlgColorRange::DlgColorRange(KisView2 * view, KisPaintDeviceSP dev, QWidget *  p
     setMainWidget(m_page);
     resize(m_page->sizeHint());
 
-    // XXX_SELECTION
-    // if (m_view->image()->undo()) m_transaction = new KisSelectedTransaction(i18n("Select by Color Range"), m_dev);
+
+#warning "Activate transactions for colorrange selections!"
+//    XXX_SELECTION
+//    m_transaction = new KisSelectedTransaction(i18n("Select by Color Range"), m_dev);
 
     KisSelectionSP selection = m_view->selection();
 
@@ -246,9 +248,9 @@ void DlgColorRange::updatePreview()
 
 void DlgColorRange::okClicked()
 {
-    if (m_view && m_view->undoAdapter() && m_transaction) {
-        m_view->undoAdapter()->addCommand(m_transaction);
-    }
+//    m_transaction->commit(m_view->image()->undoAdapter());
+//    delete m_transaction;
+
     accept();
 }
 
@@ -256,9 +258,10 @@ void DlgColorRange::cancelClicked()
 {
     if (!m_view) return;
     if (!m_view->image()) return;
-    if (!m_transaction) return;
+//    if (!m_transaction) return;
 
-    if (m_view->image()->undo()) m_transaction->undo();
+//    m_transaction->revert();
+//    delete m_transaction;
 
     m_view->canvas()->update();
     reject();
diff --git a/krita/plugins/extensions/colorspaceconversion/colorspaceconversion.cc b/krita/plugins/extensions/colorspaceconversion/colorspaceconversion.cc
index 8e033da..77b95cb 100644
--- a/krita/plugins/extensions/colorspaceconversion/colorspaceconversion.cc
+++ b/krita/plugins/extensions/colorspaceconversion/colorspaceconversion.cc
@@ -106,8 +106,7 @@ void ColorSpaceConversion::slotImageColorSpaceConversion()
         const KoColorSpace * cs = dlgColorSpaceConversion->m_page->colorSpaceSelector->currentColorSpace();
 
         QApplication::setOverrideCursor(KisCursor::waitCursor());
-        image->convertTo(cs, (KoColorConversionTransformation::Intent)dlgColorSpaceConversion->m_intentButtonGroup.checkedId());
-        image->rootLayer()->setDirty();
+        image->convertImageColorSpace(cs, (KoColorConversionTransformation::Intent)dlgColorSpaceConversion->m_intentButtonGroup.checkedId());
         QApplication::restoreOverrideCursor();
     }
     delete dlgColorSpaceConversion;
@@ -133,16 +132,12 @@ void ColorSpaceConversion::slotLayerColorSpaceConversion()
 
         const KoColorSpace * cs = dlgColorSpaceConversion->m_page->colorSpaceSelector->currentColorSpace();
 
-        if (image->undo()) {
-            image->undoAdapter()->beginMacro(i18n("Convert Layer Type"));
-        }
+        image->undoAdapter()->beginMacro(i18n("Convert Layer Type"));
 
         KisColorSpaceConvertVisitor visitor(image, cs, (KoColorConversionTransformation::Intent)dlgColorSpaceConversion->m_intentButtonGroup.checkedId());
         layer->accept(visitor);
 
-        if (image->undo()) {
-            image->undoAdapter()->endMacro();
-        }
+        image->undoAdapter()->endMacro();
 
         QApplication::restoreOverrideCursor();
         m_view->nodeManager()->nodesUpdated();
diff --git a/krita/plugins/extensions/dropshadow/kis_dropshadow.cc b/krita/plugins/extensions/dropshadow/kis_dropshadow.cc
index df70896..4a90b8a 100644
--- a/krita/plugins/extensions/dropshadow/kis_dropshadow.cc
+++ b/krita/plugins/extensions/dropshadow/kis_dropshadow.cc
@@ -88,9 +88,7 @@ void KisDropshadow::dropshadow(KoUpdater * progressUpdater,
     KisPaintDeviceSP dev = m_view->activeDevice();
     if (!dev) return;
 
-    if (image->undo()) {
-        image->undoAdapter()->beginMacro(i18n("Add Drop Shadow"));
-    }
+    image->undoAdapter()->beginMacro(i18n("Add Drop Shadow"));
 
     KisPaintDeviceSP shadowDev = new KisPaintDevice(KoColorSpaceRegistry::instance()->rgb8());
     KisPaintDeviceSP bShadowDev;
@@ -166,9 +164,7 @@ void KisDropshadow::dropshadow(KoUpdater * progressUpdater,
         m_view->image()->setModified();
     }
 
-    if (image->undo()) {
-        image->undoAdapter()->endMacro();
-    }
+    image->undoAdapter()->endMacro();
 
     progressUpdater->setProgress(100);
 }
diff --git a/krita/plugins/extensions/scripting/kritacore/krs_image.cpp b/krita/plugins/extensions/scripting/kritacore/krs_image.cpp
index a55826d..5e0616c 100644
--- a/krita/plugins/extensions/scripting/kritacore/krs_image.cpp
+++ b/krita/plugins/extensions/scripting/kritacore/krs_image.cpp
@@ -70,7 +70,7 @@ bool Image::convertToColorSpace(const QString& model, const QString& depth)
         warnScript << QString("ColorSpace %1 %2 is not available, please check your installation.").arg(model).arg(depth) << endl;
         return false;
     }
-    m_image->convertTo(dstCS);
+    m_image->convertImageColorSpace(dstCS);
     return true;
 }
 
diff --git a/krita/plugins/extensions/scripting/kritacore/krs_paint_device.cpp b/krita/plugins/extensions/scripting/kritacore/krs_paint_device.cpp
index 9436932..d808cf8 100644
--- a/krita/plugins/extensions/scripting/kritacore/krs_paint_device.cpp
+++ b/krita/plugins/extensions/scripting/kritacore/krs_paint_device.cpp
@@ -42,7 +42,7 @@ using namespace Scripting;
 PaintDevice::PaintDevice(KisPaintDeviceSP device, KisDoc2* doc)
         : ConstPaintDevice(device, doc)
         , m_device(device)
-        , m_cmd(0)
+        , m_transaction(0)
 {
     setObjectName("KritaLayer");
 }
@@ -89,11 +89,11 @@ QObject* PaintDevice::createPainter()
 
 void PaintDevice::beginPainting(const QString& name)
 {
-    if (m_cmd != 0) {
-        delete m_cmd;
+    if (m_transaction) {
+        delete m_transaction;
     }
-    m_cmd = new KisTransaction(name, paintDevice());
-    Q_CHECK_PTR(m_cmd);
+    m_transaction = new KisTransaction(name, paintDevice());
+    Q_CHECK_PTR(m_transaction);
 }
 
 void PaintDevice::endPainting()
@@ -102,8 +102,9 @@ void PaintDevice::endPainting()
         doc()->setModified(true);
         m_device->setDirty();
     }
-    if (m_cmd != 0) {
-        doc()->image()->undoAdapter()->addCommand(m_cmd);
+    if (m_transaction) {
+        m_transaction->commit(doc()->image()->undoAdapter());
+        delete m_transaction;
     }
 }
 
diff --git a/krita/plugins/extensions/scripting/kritacore/krs_paint_device.h b/krita/plugins/extensions/scripting/kritacore/krs_paint_device.h
index 6f0e84c..a5846ca 100644
--- a/krita/plugins/extensions/scripting/kritacore/krs_paint_device.h
+++ b/krita/plugins/extensions/scripting/kritacore/krs_paint_device.h
@@ -182,7 +182,7 @@ public:
     }
 private:
     KisPaintDeviceSP m_device;
-    KisTransaction* m_cmd;
+    KisTransaction* m_transaction;
 };
 
 }
diff --git a/krita/plugins/extensions/separate_channels/kis_channel_separator.cc b/krita/plugins/extensions/separate_channels/kis_channel_separator.cc
index 7db1e05..a8fc596 100644
--- a/krita/plugins/extensions/separate_channels/kis_channel_separator.cc
+++ b/krita/plugins/extensions/separate_channels/kis_channel_separator.cc
@@ -207,8 +207,8 @@ void KisChannelSeparator::separate(KoUpdater * progressUpdater, enumSepAlphaOpti
 
     if (!progressUpdater->interrupted()) {
 
-        KisUndoAdapter * undo = 0;
-        if (outputOps == TO_LAYERS && (undo = image->undoAdapter()) && undo->undo()) {
+        KisUndoAdapter * undo = image->undoAdapter();
+        if (outputOps == TO_LAYERS) {
             undo->beginMacro(i18n("Separate Image"));
         }
 
@@ -233,11 +233,7 @@ void KisChannelSeparator::separate(KoUpdater * progressUpdater, enumSepAlphaOpti
 
             if (outputOps == TO_LAYERS) {
                 KisPaintLayerSP l = KisPaintLayerSP(new KisPaintLayer(image.data(), ch->name(), OPACITY_OPAQUE_U8, *deviceIt));
-                if (undo && undo->undo()) {
-                    adapter.addNode(l.data(), image->rootLayer(), 0);
-                } else {
-                    image->addNode(l.data(), image->rootLayer());
-                }
+                adapter.addNode(l.data(), image->rootLayer(), 0);
             } else {
                 QStringList listMimeFilter = KoFilterManager::mimeFilter("application/x-krita", KoFilterManager::Export);
                 QString mimelist = listMimeFilter.join(" ");
@@ -279,7 +275,7 @@ void KisChannelSeparator::separate(KoUpdater * progressUpdater, enumSepAlphaOpti
             ++deviceIt;
         }
 
-        if (outputOps == TO_LAYERS && undo && undo->undo()) {
+        if (outputOps == TO_LAYERS) {
             undo->endMacro();
         }
         m_view->image()->unlock();
diff --git a/krita/plugins/extensions/tonemapping/kis_tonemapping_dialog.cc b/krita/plugins/extensions/tonemapping/kis_tonemapping_dialog.cc
index c1287e7..9de2207 100644
--- a/krita/plugins/extensions/tonemapping/kis_tonemapping_dialog.cc
+++ b/krita/plugins/extensions/tonemapping/kis_tonemapping_dialog.cc
@@ -79,33 +79,25 @@ KisToneMappingDialog::KisToneMappingDialog(QWidget* parent, KisLayerSP _layer) :
 
 void KisToneMappingDialog::apply()
 {
+    KisUndoAdapter *undoAdapter = d->layer->image()->undoAdapter();
+
     d->layer->image()->lock();
     KisPropertiesConfiguration* config = (d->currentConfigurationWidget) ? d->currentConfigurationWidget->configuration() : new KisPropertiesConfiguration;
     const KoColorSpace* colorSpace = d->currentOperator->colorSpace();
 
-    if (d->layer->image()->undo()) {
-        d->layer->image()->undoAdapter()->beginMacro(d->currentOperator->name());
-    }
+    undoAdapter->beginMacro(d->currentOperator->name());
+
     if (!(*d->layer->paintDevice()->colorSpace() == *colorSpace)) {
         QUndoCommand* cmd = d->layer->paintDevice()->convertTo(colorSpace);
-        if (d->layer->image()->undo()) {
-            d->layer->image()->undoAdapter()->addCommand(cmd);
-        } else {
-            delete cmd;
-        }
+        undoAdapter->addCommand(cmd);
     }
-    KisTransaction * cmd = 0;
 
-    if (d->layer->image()->undo()) cmd = new KisTransaction(d->currentOperator->name(), d->layer->paintDevice());
+    KisTransaction transaction(d->currentOperator->name(), d->layer->paintDevice());
     d->currentOperator->toneMap(d->layer->paintDevice(), config);
-    if (cmd) d->layer->image()->undoAdapter()->addCommand(cmd);
+    transaction.commit(undoAdapter);
+    undoAdapter->endMacro();
 
     d->currentOperator->bookmarkManager()->save(KisBookmarkedConfigurationManager::ConfigLastUsed.id(), config);
-
-    if (d->layer->image()->undo()) {
-        d->layer->image()->undoAdapter()->endMacro();
-    }
-
     d->layer->setDirty();
     d->layer->image()->unlock();
     delete config;
diff --git a/krita/plugins/filters/imageenhancement/kis_simple_noise_reducer.cpp b/krita/plugins/filters/imageenhancement/kis_simple_noise_reducer.cpp
index dddeaa1..4c71693 100644
--- a/krita/plugins/filters/imageenhancement/kis_simple_noise_reducer.cpp
+++ b/krita/plugins/filters/imageenhancement/kis_simple_noise_reducer.cpp
@@ -110,8 +110,8 @@ void KisSimpleNoiseReducer::process(KisConstProcessingInformation srcInfo,
     KisConvolutionPainter painter(interm);
     painter.beginTransaction("bouuh");
     painter.applyMatrix(kernel, interm, srcTopLeft, dstTopLeft, size, BORDER_REPEAT);
-    delete painter.endTransaction();
-    
+    painter.deleteTransaction();
+
     if (progressUpdater && progressUpdater->interrupted()) {
         return;
     }
diff --git a/krita/plugins/filters/unsharp/kis_unsharp_filter.cpp b/krita/plugins/filters/unsharp/kis_unsharp_filter.cpp
index 3f06eda..0a95815 100644
--- a/krita/plugins/filters/unsharp/kis_unsharp_filter.cpp
+++ b/krita/plugins/filters/unsharp/kis_unsharp_filter.cpp
@@ -109,8 +109,8 @@ void KisUnsharpFilter::process(KisConstProcessingInformation src,
     painter.setChannelFlags(channelFlags);
     painter.beginTransaction("convolution step");
     painter.applyMatrix(kernel, interm, src.topLeft(), dst.topLeft(), areaSize, BORDER_REPEAT);
-    delete painter.endTransaction();
-    
+    painter.deleteTransaction();
+
     if (progressUpdater && progressUpdater->interrupted()) {
         return;
     }
